//+------------------------------------------------------------------+
//|                                                         Qbot.mq4 |
//|                            Copyright  2007, Matthew Ebersviller |
//|                                                 version 0.2-beta |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Matthew Ebersviller"
#property link "http://www.forex-tsd.com/expert-advisors-metatrader-4/10266-ea-request-profitable-gbp-jpy-system.html"

/*********************************************************************
* This EA is based upon the rules posted by Lepiricus in a forum at  *
* Forex-TSD.com.  It utilized the QQE indicator posted by lepiricus. *
* I do not know who to credit for the QQE indicator, but I know it   *
* was not created by myself, Matthew Ebersviller.  I take no credit  *
* (or responsibility) for the EA.                                    *
*                                                                    *
* The EA works on Crossovers of the QQE on the 30 and 60 minute time *
* frames.  If you want to know more, read the messages at the forum. *
* The messages are at the URL in the link property of this EA.       *
*********************************************************************/

extern int SL = 100;
extern int TP = 150;
extern double Lots = 0.1;
extern bool TrailingStop = True;
extern int Slippage = 3;

int MagicNumber = 1101;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   return(0); // I see no need for any init in this EA, but I included
              // it for completeness
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
  return(0);  // I see no need for any deinit in this EA, but I included
              // it for completeness
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   
   int total, ticket, count;
   total = OrdersTotal();
   
   checkForExits(total, count);
   checkForEntries(total, ticket);

   return(0);
}

//
// End of EA logic
//


////////////////////////////////////
// Custom Functions Defined Below //
////////////////////////////////////

void checkForEntries(int total, int ticket) {
     // If there are no open orders...
   if (total < 1) {
      // If we have enough money...
      if(AccountFreeMargin()<(1000*Lots)) {
         Print("No money left. Free Margin = ", AccountFreeMargin());
         return(0);  
       }
      // Is there a buy opportunity? 
      if ( iCustom(NULL,30,"QQE",0,PRICE_CLOSE,1) > iCustom(NULL,30,"QQE",1,PRICE_CLOSE,1) 
      && iCustom(NULL,60,"QQE",0,PRICE_CLOSE,1) > iCustom(NULL,60,"QQE",1,PRICE_CLOSE,1) ) {
                
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-SL*Point,Ask+TP*Point,"Qbot v0.1-beta",MagicNumber,0,Green);
         if(ticket>0) {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
         }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
      }
       
      // Is there a sell opportunity? 
      if ( iCustom(NULL,30,"QQE",0,PRICE_CLOSE,1) < iCustom(NULL,30,"QQE",1,PRICE_CLOSE,1) 
      && iCustom(NULL,60,"QQE",0,PRICE_CLOSE,1) < iCustom(NULL,60,"QQE",1,PRICE_CLOSE,1) ) {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+SL*Point,Bid-TP*Point,"Qbot v0.1-beta",MagicNumber,0,Green);
         if(ticket>0) {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
         }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
      }
   }
}

void checkForExits(int total, int count) {
  for(count=0;count<total;count++) {
     OrderSelect(count, SELECT_BY_POS, MODE_TRADES);
     if (OrderType()<=OP_SELL && OrderSymbol()==Symbol()) {  // check for open position
        if (OrderType()==OP_BUY) {   // long position is opened
           // should it be closed?
           if (iCustom(NULL,30,"QQE",0,PRICE_CLOSE,1) < iCustom(NULL,30,"QQE",1,PRICE_CLOSE,1)) {
                OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet); // close position
                return(0);
            }
           // check for trailing stop (long)
           if(TrailingStop) {                 
              if(Ask-OrderOpenPrice()>Point*SL) {
                 if(OrderStopLoss()<Ask-Point*SL) {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Ask-Point*SL,OrderTakeProfit(),0,Green);
                    return(0);
                 }
              }
           }
        }
        else { // go to short position
           // should it be closed?
           if(iCustom(NULL,30,"QQE",0,PRICE_CLOSE,1) > iCustom(NULL,30,"QQE",1,PRICE_CLOSE,1)) {
              OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet); // close position
              return(0);
           }
           // check for trailing stop (short)
           if(TrailingStop) {                 
              if((OrderOpenPrice()-Ask)>(Point*SL)) {
                 if((OrderStopLoss()>(Ask+Point*SL)) || (OrderStopLoss()==0)) {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Bid+SL*Point,OrderTakeProfit(),0,Red);
                    return(0);
                 }
              }
           }
        }
     }
  }
}